# Generated by Django 5.0.9 on 2024-09-10 12:58

import django.db.models.deletion
import taggit.managers
import utilities.json
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ('adestis_netbox_plugin_account_management', '0011_delete_person'),
        ('extras', '0116_custom_link_button_color'),
        ('tenancy', '0015_contactassignment_rename_content_type'),
    ]

    operations = [
        migrations.CreateModel(
            name='SshKey',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True, null=True)),
                ('last_updated', models.DateTimeField(auto_now=True, null=True)),
                ('custom_field_data', models.JSONField(blank=True, default=dict, encoder=utilities.json.CustomFieldJSONEncoder)),
                ('raw_ssh_key', models.CharField(max_length=800)),
                ('key_comment', models.CharField(blank=True, max_length=256, null=True)),
                ('encoded_key', models.CharField(blank=True, max_length=800, null=True)),
                ('key_type', models.CharField(blank=True, max_length=50, null=True)),
                ('ssh_key_status', models.CharField(max_length=50)),
                ('valid_from', models.DateField(blank=True, null=True)),
                ('valid_to', models.DateField(blank=True, null=True)),
                ('comments', models.TextField(blank=True)),
                ('contact', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, related_name='SshKey_contact', to='tenancy.contact')),
                ('tags', taggit.managers.TaggableManager(through='extras.TaggedItem', to='extras.Tag')),
            ],
            options={
                'verbose_name': 'SSH Key',
                'verbose_name_plural': 'SSH Keys',
                'ordering': ('contact',),
            },
        ),
        migrations.AddField(
            model_name='logincredentials',
            name='ssh_keys',
            field=models.ManyToManyField(blank=True, related_name='logincredentials_sshkey', to='adestis_netbox_plugin_account_management.sshkey'),
        ),
        migrations.AddConstraint(
            model_name='sshkey',
            constraint=models.UniqueConstraint(fields=('key_type', 'encoded_key'), name='adestis_netbox_plugin_account_management_sshkey_unique_ssh_key'),
        ),
    ]
